package com.sleepycat.je.dbi;

import com.sleepycat.je.DatabaseException;
import com.sleepycat.je.tree.BIN;
import com.sleepycat.je.tree.LN;

public privileged aspect CursorBudget {

	//TODO homogenic only because of hook methods 
	Object around(BIN targetBin, LN ln) throws DatabaseException :
		(execution(* CursorImpl.hook_lnDelete(..)) || 
				execution(* CursorImpl.hook_lnModify(..))) && 
		args(targetBin,ln,..) {

		long oldLNSize = ln.getMemorySizeIncludedByParent();
		Object r = proceed(targetBin, ln);
		long newLNSize = ln.getMemorySizeIncludedByParent();
		targetBin.updateMemorySize(oldLNSize, newLNSize);

		return r;
	}
	

}
