package com.sleepycat.je.dbi;

import com.sleepycat.je.tree.IN;

public privileged aspect INListBudget {

	private boolean INList.updateMemoryUsage;

	after(INList inlist):
		execution(INList.new(EnvironmentImpl)) && this(inlist) {

		inlist.updateMemoryUsage = true;
	}

	after(INList inlist):
		execution(INList.new(INList, EnvironmentImpl)) && this(inlist) {

		inlist.updateMemoryUsage = false;
	}

	after(IN in, INList inlist):
		execution(void INList.add(IN)) && args(in) && this(inlist) {

		if (inlist.updateMemoryUsage) {
			MemoryBudget mb = inlist.envImpl.getMemoryBudget();
			mb.updateTreeMemoryUsage(in.getInMemorySize());
			in.setInListResident(true);
		}
	}

	after(IN in, INList inlist):
		execution(void INList.remove(IN)) && args(in) && this(inlist) {

		if (inlist.updateMemoryUsage) {
			MemoryBudget mb = inlist.envImpl.getMemoryBudget();
			mb.updateTreeMemoryUsage(in.getAccumulatedDelta()
					- in.getInMemorySize());
			in.setInListResident(false);
		}

	}

	after(INList inlist):
		execution(void INList.clear()) && this(inlist) {

		if (inlist.updateMemoryUsage) {
			inlist.envImpl.getMemoryBudget().refreshTreeMemoryUsage(0);
		}

	}

	private boolean IN.inListResident; // true if this IN is on the IN list

	public void IN.setInListResident(boolean resident) {
		inListResident = resident;
	}

	after(IN in):execution(void IN.init(DatabaseImpl, byte[], int, int)) && this(in) {
		in.inListResident = false;
	}

}
