package com.sleepycat.je.dbi;

import java.util.Iterator;
import java.util.Set;

import com.sleepycat.je.tree.IN;

public privileged aspect TreeWalkerBudget {
	
	
	private void updateTreeMemoryUsage(SortedLSNTreeWalker tw, long memoryChange) {
		MemoryBudget mb=tw.envImpl.getMemoryBudget();
		mb.updateTreeMemoryUsage(memoryChange);
	}
	
	//TODO does not keep semantics exactly. calls updateTreeMemory on every single change,
	//not batched as before.
	//this hightly rises synchronisation effort
	//-> already made some performance optimisation in the original source code that are hard to reimplement with aspects
	after(SortedLSNTreeWalker tw) returning(Object r) :
		 call(void Iterator.remove()) && 
		 withincode(void SortedLSNTreeWalker.hook_findInternal(INList,Set)) && this(tw) {
		
		IN thisIN = (IN) r;
		long memoryChange = (thisIN.getAccumulatedDelta() - thisIN.getInMemorySize());
		thisIN.setInListResident(false);
		updateTreeMemoryUsage(tw, memoryChange);
	}

}
